/**
 * Title:       Demand queue receiver for job2me project
 * ClassName:   DemandReceiverNoReply.java
 * Created:     March 22, 2015
 * Author:      Claudiu Vinte
 * Department:  Economic Informatics, The Bucharest University of Economic Studies
 *
 * Description: Implements an Demand queue receiver, by extending AbstractQueueReceiverNoReply class
 */

package job2me.jms.api;

import job2me.data.api.Demand;
import job2me.data.api.Enums;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.ObjectMessage;


public class DemandReceiverNoReply extends AbstractQueueReceiver
{
    public DemandReceiverNoReply(String imqAddress, String queueName, String userID)
            throws JMSException, Exception
    {
        super(imqAddress, queueName, userID);
    }

    // Receive messages from Demand queue
    @Override
    public void onMessage(Message message)
    {
        try
        {
            if (message instanceof ObjectMessage)
            {   
                if (message.getStringProperty("MSG_TYPE").equals(Enums.MessageType.OFFER.toString()))
                // Company Demands are received by DOME
                
                // TO DO in the derived class
 
                {
                    ObjectMessage objectMessage = (ObjectMessage)message;
                    processDemand((Demand)objectMessage.getObject());
                }
            }
        } catch (JMSException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    protected void processDemand(Demand demand) throws Exception
    {

        // TO DO in the derived class

    }
    
}