/**
 * Title:       Demand queue sender for job2me project
 * ClassName:   DemandSenderNoReply.java
 * Created:     March 22, 2015
 * Author:      Claudiu Vinte
 * Department:  Economic Informatics, The Bucharest University of Economic Studies
 *
 * Description: Implements a Demand queue sender, by extending AbstractQueueSenderNoReply class
 */

package job2me.jms.api;

import job2me.data.api.Demand;
import job2me.data.api.Enums;

import javax.jms.JMSException;
import javax.jms.ObjectMessage;


public class DemandSenderNoReply extends AbstractQueueSenderNoReply
{
    public DemandSenderNoReply(String imqAddress, String queueName, String userID)
            throws JMSException, Exception
    {
        super(imqAddress, queueName, userID);
    }

    // Create and send an Demand message
    public void sendDemand(Demand demand) throws JMSException
    {
        // Construct the message as an ObjectMessage (Demand)
        ObjectMessage message = this.getSession().createObjectMessage();
        message.setObject(demand);

        message.setStringProperty("MSG_TYPE", Enums.MessageType.DEMAND.toString());
        message.setStringProperty("USER_ID", this.getUserID());

        // Company Demands are received by DOME
        
        // TO DO in the derived class

        this.getSender().send(message);
    }
    
}

