/**
 * Title:       Offer queue receiver for job2me project
 * ClassName:   OfferReceiverNoReply.java
 * Created:     March 22, 2015
 * Author:      Claudiu Vinte
 * Department:  Economic Informatics, The Bucharest University of Economic Studies
 *
 * Description: Implements an Offer queue receiver, by extending AbstractQueueReceiverNoReply class
 */

package job2me.jms.api;

import job2me.data.api.Offer;
import job2me.data.api.Enums;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.ObjectMessage;


public class OfferReceiverNoReply extends AbstractQueueReceiver
{
    public OfferReceiverNoReply(String imqAddress, String queueName, String userID)
            throws JMSException, Exception
    {
        super(imqAddress, queueName, userID);
    }

    // Receive messages from Offer queue
    @Override
    public void onMessage(Message message)
    {
        try
        {
            if (message instanceof ObjectMessage)
            {   
                if (message.getStringProperty("MSG_TYPE").equals(Enums.MessageType.OFFER.toString())&&
                        message.getStringProperty("USER_ID").equals("PRODS-Offer"))
                // Company Offers are received by DOME
                
                // TO DO in the derived class
 
                {
                    ObjectMessage objectMessage = (ObjectMessage)message;
                    processOffer((Offer)objectMessage.getObject());
                }
            }
        } catch (JMSException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    protected void processOffer(Offer offer) throws Exception
    {

        // TO DO in the derived class

    }
    
}